# podman-init

`podman-init` is a Python command-line tool that automates the process of initializing Docker-related files for your projects. With `podman-init`, you can quickly generate Dockerfile, docker-compose.yml, and .dockerignore files tailored to your project's language and framework, saving you time and effort during project setup.

## Features

- Interactive shell for creating Docker-related files
- Supports multiple languages and frameworks (Python with Flask/Django, Java with Spring, etc.)
- Easy-to-use command-line interface
- Automates common tasks for Dockerfile generation

## Installation

You can install `podman-init` via pip:

```bash
pip install podman-init
```

## Usage

Simply run podman-init and follow the prompts to generate Docker-related files for your project.

```bash
podman-init
```

Contributions are welcome! If you encounter any issues or have suggestions for improvements, please feel free to open an issue or submit a pull request.
